-module(tree).
-compile([export_all,{no_auto_import,[max/2]}]).
-author('hanak@iit.bme.hu, modified by: kapolnai@iit.bme.hu').
-vsn('$LastChangedDate: 2011-10-20 20:16:44 +0200 (cs, 20 okt 2011) $$').

% @type btree() = leaf | {any(),btree(),btree()}.

% Üres fa. 
empty() -> leaf.

% Lt és Rt fák összekapcsolása egy új V értékű csomóponttal.
node(V, Lt, Rt) -> {V,Lt,Rt}.

max(X, Y) when X>Y -> X;
max(_X, Y)         -> Y.

% Fa legnagyobb mélysége.
depth(leaf)      -> 0;
depth({_,Lt,Rt}) -> 1 + max(depth(Lt), depth(Rt)).

% Fa leveleinek száma.
leaves(leaf)      -> 1;
leaves({_,Lt,Rt}) -> leaves(Lt) + leaves(Rt).

%% ilist(N) -> lists:seq(1,N,1).
%% alist(F,N) -> lists:map(fun(X) -> list_to_atom([X-1+F]) end, ilist(N)).

% Fa listává alakítása infix bejárással.
to_list_infix(leaf) ->
    [];
to_list_infix({V,Lt,Rt}) ->
    to_list_infix(Lt) ++ [V] ++ to_list_infix(Rt).

% Fa listává alakítása prefix bejárással.
to_list_prefix(leaf) ->
    [];
to_list_prefix({V,Lt,Rt}) ->
    [V] ++ to_list_prefix(Lt) ++ to_list_prefix(Rt).

% Listából felépít egy fát.
from_list([]) ->
    empty();
from_list(L) ->
    {L1,[X|L2]} = lists:split(length(L) div 2, L),
    node(X, from_list(L1), from_list(L2)).

test(1) ->
%%                 1
%%             2       5
%%           3   4   6   7
%%          - - - - - - - -
    L = empty(),
    node(1,
         node(2,
              node(3,L,L),
              node(4,L,L)
             ),
         node(5,
              node(6,L,L),
              node(7,L,L)
             )
        );
test(2) ->
    from_list([a,b,c,d,e,f,g]);
test(3) ->
    to_list_infix(test(2));
test(4) ->
    to_list_prefix(test(2)).
